/*
 *      Include file of form handler
 *
 *      Authors: David Hsu	<davidhsu@realtek.com.tw>
 *
 *      $Id: apform.h,v 1.1.1.1 2005/05/18 09:58:34 CAMEO+brian Exp $
 *
 */

#ifndef _INCLUDE_APFORM_H
#define _INCLUDE_APFORM_H

#if HAVE_STDBOOL_H
# include <stdbool.h>
#else
typedef enum {false = 0, true = 1} bool;
#endif

#ifdef __i386__
  #define _CONFIG_SCRIPT_PATH	T(".")
  #define _LITTLE_ENDIAN_
#else
  #define _CONFIG_SCRIPT_PATH	T("/bin")
#endif

#define _CONFIG_SCRIPT_PROG	T("init.sh")
#define _WLAN_SCRIPT_PROG	T("wlan.sh")
#define _PPPOE_SCRIPT_PROG	T("pppoe.sh")
#define _FIREWALL_SCRIPT_PROG	T("firewall.sh")
#define _ROUTE_SCRIPT_PROG	T("route.sh")
#define _PPPOE_DC_SCRIPT_PROG	T("disconnect.sh")
#define _IAPPAUTH_SCRIPT_PROG	T("iappauth.sh")
#define _NTP_SCRIPT_PROG	T("ntp.sh")
#ifdef HOME_GATEWAY
#ifdef VPN_SUPPORT
#define _VPN_SCRIPT_PROG	T("vpn.sh")
#endif
#endif
#define _WLAN_APP_SCRIPT_PROG	T("wlanapp.sh")

#ifdef WLAN_EASY_CONFIG
#define _AUTO_CONFIG_DAEMON_PROG T("autoconf")
#endif

///////////////////////////////////////////////////////////////////////////
static bool _is_hex(char c)
{
    return (((c >= '0') && (c <= '9')) ||
            ((c >= 'A') && (c <= 'F')) ||
            ((c >= 'a') && (c <= 'f')));
}

// Validate digit
static bool _isdigit(char c)
{
    return ((c >= '0') && (c <= '9'));
}

static int __inline__ string_to_hex(char_t *string, unsigned char *key, int len)
{
	char tmpBuf[4];
	int idx, ii=0;
	for (idx=0; idx<len; idx+=2) {
		tmpBuf[0] = string[idx];
		tmpBuf[1] = string[idx+1];
		tmpBuf[2] = 0;
		if ( !_is_hex(tmpBuf[0]) || !_is_hex(tmpBuf[1]))
			return 0;

		key[ii++] = (unsigned char) strtol(tmpBuf, (char**)NULL, 16);
	}
	return 1;
}

static int __inline__ string_to_dec(char_t *string, int *val)
{
	int idx;
	int len = strlen(string);

	for (idx=0; idx<len; idx++) {
		if ( !_isdigit(string[idx]))
			return 0;
	}

	*val = strtol(string, (char**)NULL, 10);
	return 1;
}

#define ERR_MSG(msg) { \
	websHeader(wp); \
	websWrite(wp, T("<HEAD><TITLE>DWL-G700AP</TITLE><BODY text=#000000 bgColor=#ffffff topMargin=0>\n")); \
	websWrite(wp, T("<TABLE cellSpacing=0 cellPadding=0 width=765 align=center border=0>\n")); \
	websWrite(wp, T("<TBODY><TR><TD><IMG height=95 src=\"/images/home_01.jpg\" width=765></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD background=/images/home_02.jpg><DIV align=left>\n")); \
	websWrite(wp, T("<TABLE height=\"131\" cellSpacing=0 cellPadding=0 width=\"500\" align=center border=0>\n")); \
	websWrite(wp, T("<TBODY><TR><TD><DIV align=center><FONT face=Arial><B></B></FONT></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD>&nbsp;</TD></TR><TR><TD><DIV align=center>\n")); \
	websWrite(wp, T("<FONT face=Arial color=#000000 size=2>%s<BR></FONT></DIV></TD></TR>\n"), msg); \
	websWrite(wp, T("<TR><TD>&nbsp;</TD></TR><TR><TD><DIV align=center>\n")); \
	websWrite(wp, T("<A href=\"javascript:history.go (-1)\">\n")); \
	websWrite(wp, T("<IMG height=35 src=\"/images/continue_p.gif\" width=70 border=0></A></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD><DIV align=center></DIV></TD></TR></TBODY></TABLE></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD background=/images/home_03.jpg><DIV align=right>\n")); \
	websWrite(wp, T("<IMG height=27 src=\"/images/down_44.gif\" width=25></DIV></TD></TR></TBODY></TABLE></BODY>\n")); \
   	websFooter(wp); \
	websDone(wp, 200); \
}

#define OK_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<HEAD><TITLE>DWL-G700AP</TITLE><BODY text=#000000 bgColor=#ffffff topMargin=0>\n")); \
	websWrite(wp, T("<TABLE cellSpacing=0 cellPadding=0 width=765 align=center border=0>\n")); \
	websWrite(wp, T("<TBODY><TR><TD><IMG height=95 src=\"/images/home_01.jpg\" width=765></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD background=/images/home_02.jpg><DIV align=left>\n")); \
	websWrite(wp, T("<TABLE height=\"131\" cellSpacing=0 cellPadding=0 width=\"500\" align=center border=0>\n")); \
	websWrite(wp, T("<TBODY><TR><TD><DIV align=center><FONT face=Arial><B></B></FONT></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD>&nbsp;</TD></TR><TR><TD><DIV align=center>\n")); \
	websWrite(wp, T("<FONT face=Arial color=#000000 size=2>Change setting successfully! <BR></FONT></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD>&nbsp;</TD></TR><TR><TD><DIV align=center>\n")); \
	if (url[0]) websWrite(wp, T("<A href=javascript:window.location.replace(\"%s\")>\n"), url); \
	else websWrite(wp, T("<A href=\"javascript:window.close()\">\n")); \
	websWrite(wp, T("<IMG height=35 src=\"/images/continue_p.gif\" width=70 border=0></A></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD><DIV align=center></DIV></TD></TR></TBODY></TABLE></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD background=/images/home_03.jpg><DIV align=right>\n")); \
	websWrite(wp, T("<IMG height=27 src=\"/images/down_44.gif\" width=25></DIV></TD></TR></TBODY></TABLE></BODY>\n")); \
   	websFooter(wp); \
	websDone(wp, 200); \
}

#define WIZARD_OK_MSG(url) { \
	websHeader(wp); \
	websWrite(wp, T("<HEAD><TITLE>setup wizard</TITLE><BODY bgcolor=\"#CCCCCC\" text=\"#000000\" topmargin=\"0\" leftmargin=\"0\">\n")); \
	websWrite(wp, T("<table border=0 cellspacing=0 cellpadding=0 height=211 width=450>\n")); \
	websWrite(wp, T("<tr> <td height=11><img src=\"/images/ww.jpg\" width=450 height=34></td></tr><TR><td>\n")); \
	websWrite(wp, T("<table><td bgcolor=#CCCCCC height=10></td></tr>\n")); \
	websWrite(wp, T("<td height=10 bgcolor=#CCCCCC valign=top><table border=0 width=450 cellpadding=0 height=175><tr><td colspan=2 height=10>&nbsp;</td></tr><tr bgcolor=#CCCCCC valign=top><td colspan=2 height=2></td></tr>\n")); \
	websWrite(wp, T("<tr><td colspan=2 height=14><div align=center><font face=Arial size=2>Change setting successfully! </font><font face=Arial></font></div></td></tr>\n")); \
	websWrite(wp, T("<tr><td width=156 height=10></td><td width=284 bgcolor=#CCCCCC height=10></td></tr>\n")); \
	websWrite(wp, T("<tr><td width=156 height=10>&nbsp;</td><td width=284 bgcolor=#CCCCCC height=10>&nbsp;</td></tr>\n")); \
	websWrite(wp, T("<tr><td width=156 height=10>&nbsp;</td><td width=284 bgcolor=#CCCCCC height=10>&nbsp;</td></tr><tr><td width=156 height=10>&nbsp;</td>\n")); \
	websWrite(wp, T("<td width=284 bgcolor=#CCCCCC height=10>&nbsp;</td></tr></table></td></tr>\n")); \
	websWrite(wp, T("<tr><td bgcolor=#CCCCCC height=10 align=right><div align=center>\n")); \
	websWrite(wp, T("<input type=\"button\" value=\"Close\" name=\"close\" onClick=\"window.close()\"></div>\n")); \
	websWrite(wp, T("</td></tr></table></body>\n")); \
   	websFooter(wp); \
	websDone(wp, 200); \
}

#define OK_MSG1(msg, url) { \
	websHeader(wp); \
	websWrite(wp, T("<HEAD><TITLE>DWL-G700AP</TITLE><BODY text=#000000 bgColor=#ffffff topMargin=0>\n")); \
	websWrite(wp, T("<TABLE cellSpacing=0 cellPadding=0 width=765 align=center border=0>\n")); \
	websWrite(wp, T("<TBODY><TR><TD><IMG height=95 src=\"/images/home_01.jpg\" width=765></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD background=/images/home_02.jpg><DIV align=left>\n")); \
	websWrite(wp, T("<TABLE height=\"131\" cellSpacing=0 cellPadding=0 width=\"500\" align=center border=0>\n")); \
	websWrite(wp, T("<TBODY><TR><TD><DIV align=center><FONT face=Arial><B></B></FONT></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD>&nbsp;</TD></TR><TR><TD><DIV align=center>\n")); \
	websWrite(wp, T("<FONT face=Arial color=#000000 size=2>%s<BR></FONT></DIV></TD></TR>\n"), msg); \
	websWrite(wp, T("<TR><TD>&nbsp;</TD></TR><TR><TD><DIV align=center>\n")); \
	if (url[0]) websWrite(wp, T("<A href=javascript:window.location.replace(\"%s\")>\n"), url); \
	else websWrite(wp, T("<A href=\"javascript:window.close()\">\n")); \
	websWrite(wp, T("<IMG height=35 src=\"/images/continue_p.gif\" width=70 border=0></A></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD><DIV align=center></DIV></TD></TR></TBODY></TABLE></DIV></TD></TR>\n")); \
	websWrite(wp, T("<TR><TD background=/images/home_03.jpg><DIV align=right>\n")); \
	websWrite(wp, T("<IMG height=27 src=\"/images/down_44.gif\" width=25></DIV></TD></TR></TBODY></TABLE></BODY>\n")); \
   	websFooter(wp); \
	websDone(wp, 200); \
}

//////////////////////////////////////////////////////////////////////////

/* Routines exported in fmmgmt.c */
extern int sysLogList(int eid, webs_t wp, int argc, char_t **argv);
extern void formPasswordSetup(webs_t wp, char_t *path, char_t *query);
extern void formUpload(webs_t wp, char_t * path, char_t * query);
#ifdef TLS_CLIENT
extern void formCertUpload(webs_t wp, char_t * path, char_t * query);
#endif
extern void formSaveConfig(webs_t wp, char_t *path, char_t *query);
extern void set_user_profile();
extern void formStats(webs_t wp, char_t *path, char_t *query);
extern void formLogout(webs_t wp, char_t *path, char_t *query);
extern void formSysCmd(webs_t wp, char_t *path, char_t *query);
extern int sysCmdLog(int eid, webs_t wp, int argc, char_t **argv);
extern void formSysLog(webs_t wp, char_t *path, char_t *query);
extern int sysLogList(int eid, webs_t wp, int argc, char_t **argv);
extern int currentLogPage(int eid, webs_t wp, int argc, char_t **argv);
extern int lastLogPage(int eid, webs_t wp, int argc, char_t **argv);
#ifdef HOME_GATEWAY
// by sc_yang
extern void formNtp(webs_t wp, char_t *path, char_t *query);
extern void formOpMode(webs_t wp, char_t *path, char_t *query);
#endif
extern void formWizard(webs_t wp, char_t *path, char_t *query);

/* Routines exported in fmget.c */
extern int getIndex(int eid, webs_t wp, int argc, char_t **argv);
extern int getInfo(int eid, webs_t wp, int argc, char_t **argv);
extern int isConnectPPP();

/* Routines exported in fmwlan.c */
extern void formWirelessSetup(webs_t wp, char_t *path, char_t *query);

extern void formWlanSetup(webs_t wp, char_t *path, char_t *query);
extern int wlAcList(int eid, webs_t wp, int argc, char_t **argv);
extern void formWlAc(webs_t wp, char_t *path, char_t *query);
extern void formAdvanceSetup(webs_t wp, char_t *path, char_t *query);
extern int wirelessClientList(int eid, webs_t wp, int argc, char_t **argv);
extern void formWirelessTbl(webs_t wp, char_t *path, char_t *query);
extern void formWep(webs_t wp, char_t *path, char_t *query);
extern void formWlSiteSurvey(webs_t wp, char_t *path, char_t *query);
extern int wepHandler(webs_t wp, char *tmpBuf, int wlan_id);
extern int wlanHandler(webs_t wp, char *tmpBuf, int *mode, int wlan_id); 
extern int wpaHandler(webs_t wp, char *tmpBuf, int wlan_id);
extern void formWlanRedirect(webs_t wp, char_t *path, char_t *query);
#ifdef TLS_CLIENT
extern int certRootList(int eid, webs_t wp, int argc, char_t **argv);
extern int certUserList(int eid, webs_t wp, int argc, char_t **argv);
#endif

int wlSiteSurveyTbl(int eid, webs_t wp, int argc, char_t **argv);
extern void formWlEncrypt(webs_t wp, char_t *path, char_t *query);

extern void formWlWds(webs_t wp, char_t *path, char_t *query);
extern int wlWdsList(int eid, webs_t wp, int argc, char_t **argv);
extern void formWdsEncrypt(webs_t wp, char_t *path, char_t *query);
extern int wdsList(int eid, webs_t wp, int argc, char_t **argv);

#ifdef WLAN_EASY_CONFIG
extern void sigHandler_autoconf(int signo);
extern void formAutoCfg(webs_t wp, char_t *path, char_t *query);
#endif

/* Routines exported in fmtcpip.c */
extern void formTcpipSetup(webs_t wp, char_t *path, char_t *query);
extern int isDhcpClientExist(char *name);
extern void formReflashClientTbl(webs_t wp, char_t *path, char_t *query);
extern int dhcpClientList(int eid, webs_t wp, int argc, char_t **argv);
extern int connectPCList(int eid, webs_t wp, int argc, char_t **argv);
extern int tcpipLanHandler(webs_t wp, char *tmpBuf);

#ifdef HOME_GATEWAY
extern void formWanTcpipSetup(webs_t wp, char_t *path, char_t *query);

/* Routines exported in fmfwall.c */
extern void formPortFw(webs_t wp, char_t *path, char_t *query);
extern void formFilter(webs_t wp, char_t *path, char_t *query);
extern int portFwList(int eid, webs_t wp, int argc, char_t **argv);
extern int portFilterList(int eid, webs_t wp, int argc, char_t **argv);
extern int ipFilterList(int eid, webs_t wp, int argc, char_t **argv);
extern int macFilterList(int eid, webs_t wp, int argc, char_t **argv);
extern void formDMZ(webs_t wp, char_t *path, char_t *query);
extern void formTriggerPort(webs_t wp, char_t *path, char_t *query);
extern int triggerPortList(int eid, webs_t wp, int argc, char_t **argv);
extern int tcpipWanHandler(webs_t wp, char * tmpBuf, int *dns_changed);
/* Routines exported in fmroute.c */
#ifdef ROUTE_SUPPORT
extern void formRoute(webs_t wp, char_t *path, char_t *query);
extern int staticRouteList(int eid, webs_t wp, int argc, char_t **argv);
extern int kernelRouteList(int eid, webs_t wp, int argc, char_t **argv);
#endif
#endif

#ifdef HOME_GATEWAY
/* Routine exported in fmddns.c */
extern void formDdns(webs_t wp, char_t *path, char_t *query);
#endif

#ifdef HOME_GATEWAY
#ifdef VPN_SUPPORT
/* Routines exported in fmvpn.c */
extern void formVpnSetup(webs_t wp, char_t *path, char_t *query);
extern void formVpnConn(webs_t wp, char_t *path, char_t *query);
//extern int vpnStatList(int eid, webs_t wp, int argc, char_t **argv);
extern int vpnConnList(int eid, webs_t wp, int argc, char_t **argv);
extern int vpnRsaList(int eid, webs_t wp, int argc, char_t **argv);
extern int vpnShowLog(int eid, webs_t wp, int argc, char_t **argv);
extern void formVpnLog(webs_t wp, char_t *path, char_t *query);
extern int getVpnTblIdx(void);
extern void len2Mask(int len, char * mask );
extern int mask2Len(char *buf);
extern int getVpnKeyMode(void);
extern int  getConnStat(char *in_connName);
#endif
#endif

/* variables exported in main.c */
#ifdef HOME_GATEWAY
extern char *WAN_IF;
extern char *BRIDGE_IF;
extern char *ELAN_IF;
extern char *PPPOE_IF;

#else
extern char *BRIDGE_IF;
extern char *ELAN_IF;
#endif
extern char WLAN_IF[];
extern int wlan_num;
extern int currentPage;
#endif // _INCLUDE_APFORM_H
