#!/bin/sh
zebra_conf=/var/etc/zebra.conf
ripd_conf=/var/etc/ripd.conf
killall zebra
killall ripd

eval `flash get RIP_ENABLED`
eval `flash get RIP_WAN_TX`
eval `flash get RIP_WAN_RX`
eval `flash get RIP_LAN_TX`
eval `flash get RIP_LAN_RX`

eval `flash get STATICROUTE_ENABLED`
eval `flash get STATICROUTE_TBL_NUM`

echo "interface br0" > $zebra_conf
echo "interface eth1" >> $zebra_conf
echo "multicast" >> $zebra_conf

echo "router rip" > $ripd_conf
echo "  network br0" >> $ripd_conf
echo "  network eth1" >> $ripd_conf
echo "  redistribute connected" >> $ripd_conf
echo "interface br0" >> $ripd_conf
if [ $RIP_LAN_TX != 0 ]; then
  if [ $RIP_LAN_TX = 3 ]; then
    echo "  ip rip send version 1 2" >> $ripd_conf
  else
    echo "  ip rip send version $RIP_LAN_TX" >> $ripd_conf
  fi
fi  
if [ $RIP_LAN_RX != 0 ]; then
  if [ $RIP_LAN_RX = 3 ]; then
    echo "  ip rip receive version 1 2" >> $ripd_conf
  else 
    echo "  ip rip receive version $RIP_LAN_RX" >> $ripd_conf
  fi
fi  
echo "interface eth1" >> $ripd_conf
if [ $RIP_WAN_TX != 0 ]; then
  if [ $RIP_WAN_TX = 3 ]; then
    echo "  ip rip send version 1 2" >> $ripd_conf
  else 
    echo "  ip rip send version $RIP_WAN_TX" >> $ripd_conf
  fi
fi  
if [ $RIP_WAN_RX != 0 ]; then
  if [ $RIP_WAN_RX = 3 ]; then
    echo "  ip rip receive version 1 2" >> $ripd_conf
  else 
    echo "  ip rip receive version $RIP_WAN_RX" >> $ripd_conf
  fi
fi
  
echo "router rip" >> $ripd_conf
if [ $RIP_LAN_TX = 0 ]; then
  echo "  distribute-list private out br0" >> $ripd_conf
fi
if [ $RIP_LAN_RX = 0 ]; then
  echo "  distribute-list private in br0" >> $ripd_conf
fi
if [ $RIP_WAN_TX = 0 ]; then
  echo "  distribute-list private out eth1" >> $ripd_conf
fi
if [ $RIP_WAN_RX = 0 ]; then
  echo "  distribute-list private in eth1" >> $ripd_conf
fi
echo "access-list private deny any" >> $ripd_conf


if [ $STATICROUTE_TBL_NUM -gt 0 ];
then
  num=1
  while [ $num -le $STATICROUTE_TBL_NUM ];
  do
    STATICROUTE_TBL=`flash get STATICROUTE_TBL | grep STATICROUTE_TBL$num`
    tmp=`echo $STATICROUTE_TBL | cut -f2 -d=`
    dstIp=`echo $tmp | cut -f1 -d,`
    netmask=`echo $tmp | cut -f2 -d,`
    gateway=`echo $tmp | cut -f3 -d,`
    route del -net $dstIp netmask $netmask gw $gateway
    num=`expr $num + 1`
  done
fi

if [ $STATICROUTE_TBL_NUM -gt 0 ] && [ $STATICROUTE_ENABLED -gt 0 ];
then
  num=1
  while [ $num -le $STATICROUTE_TBL_NUM ];
  do
    STATICROUTE_TBL=`flash get STATICROUTE_TBL | grep STATICROUTE_TBL$num`
    tmp=`echo $STATICROUTE_TBL | cut -f2 -d=`
    dstIp=`echo $tmp | cut -f1 -d,`
    netmask=`echo $tmp | cut -f2 -d,`
    gateway=`echo $tmp | cut -f3 -d,`
    route add -net $dstIp netmask $netmask gw $gateway
    num=`expr $num + 1`
  done
fi

if [ $RIP_ENABLED -gt 0 ]; then
  zebra -d
  ripd -d
fi

